lookup/http/views.py
"""
web views of the database

"""

from functools import wraps
from typing import Callable, Union
from urllib.parse import urlparse

from flask import Blueprint, g, after_this_request, current_app
from flask import request, render_template, abort, session, redirect, url_for
from werkzeug import Response

from lookup.interface import UserDatabase, PeopleDatabaseSources, TokenDatabase
from lookup.interface.api import Api
from lookup.util.web import get_remote_user, get_current_site
from lookup.util.web import get_common_args, generate_pages

web_blueprint = Blueprint("web", __name__)

# Number of results per page, shown in drop down select
LIMITS_1COL = [10, 20, 50, 100]
LIMITS_3COL = [18, 36, 72, 144]
# Available sorting options
SORTS_PEOPLE = [
    ("surname", "Surname"),
    ("display_name", "Display name"),
    ("crsid", "CRSid"),
]
SORTS_TAGS = [
    ("name", "Alphabetical"),
    ("count", "Count"),
    ("new", "New"),
    ("trending", "Trending"),
]


def login_required(view_func: Callable) -> Callable:
    """
    A valid username is required for this view.

    Decorate a view function so that requests that have no
    logged in user are redirected to the login page. Calls
    to the login page are given a argument "next" that
    points back to the original url.

    Parameters
    ----------
    view_func
        A routed view function

    Returns
    -------
    wrapped_func
        The same function wrapped in a login check

    """

    @wraps(view_func)  # Flask routing requires original function names
    def wrapped_func(*args, **kwargs) -> Response:
        if not g.user:
            return redirect(url_for("web.login", next=request.url))
        else:
            return view_func(*args, **kwargs)

    return wrapped_func


@web_blueprint.before_request
def setup_request_data():
    """
    Setup databases for the request in a global context.

    Set up a UserDatabase for the request and determine
    which user is invoking the request from the session key.

    Initialise an API authenticated by the current user.

    Sets up variables in the global context:

        g.user_db: a UserDatabase instance
        g.user: the current logged in user
        g.api: an Api initialised for the logged in user
    """
    database = current_app.config["database"]
    session_key = session.get("session_key")
    g.user_db = UserDatabase(database)
    g.user = g.user_db.get_user(
        key=session_key, agent=request.user_agent.string, address=request.remote_addr,
    )
    g.api = Api(
        database=PeopleDatabaseSources(database),
        token_database=TokenDatabase(database),
        user=g.user,
    )
    g.site = get_current_site()

    @after_this_request
    def teardown(response: Response) -> Response:
        """
        Ensure database connections are closed. Session closure
        is handled in the ``__del__`` methods of the database helpers.
        """
        del g.user_db
        del g.api
        return response


@web_blueprint.route("/")
def index() -> str:
    """Landing page with search box and some tags"""
    tags_top = g.api.get_tags(limit=20, sort="count")["data"]
    tags_new = g.api.get_tags(limit=20, sort="new")["data"]
    tags_trending = g.api.get_tags(limit=20, sort="trending")["data"]
    user_info = g.api.get_person(g.user)

    return render_template(
        "index.html",
        tags_top=tags_top,
        tags_new=tags_new,
        tags_trending=tags_trending,
        user_info=user_info,
    )


@web_blueprint.route("/login")
def login() -> Response:
    """
    Log in as the authenticated user and store in a session cookie
    Currently expects REMOTE_USER  to be set through Raven/Apache.

    Redirect to homepage after login.
    """
    session.permanent = True
    session_key = g.user_db.login(
        user_id=get_remote_user(),
        agent=request.user_agent.string,
        address=request.remote_addr,
    )
    session["session_key"] = session_key

    # Can't create a login session so error
    if not session_key:
        return abort(401)

    next_url = request.args.get("next", url_for("web.index"))
    if urlparse(next_url).netloc == urlparse(request.url).netloc:
        return redirect(next_url)
    else:
        return redirect(url_for("web.index"))


@web_blueprint.route("/logout")
def logout() -> Response:
    """
    Log out a currently logged in user and close that session.

    Redirect to homepage after logout.
    """
    g.user_db.logout(key=session["session_key"])
    session.pop("session_key", None)
    response = redirect(url_for("web.index"))
    # Make Raven re-authenticate if required
    response.delete_cookie("Ucam-WebAuth-Session")  # http (development only)
    response.delete_cookie("Ucam-WebAuth-Session-S")  # https
    return response


@web_blueprint.route("/people/")
@login_required
def people():
    args = get_common_args(request, query=None, limit=10, offset=0)

    people_data = g.api.get_people(
        query=args["query"],
        limit=args["limit"],
        offset=args["offset"],
        full=True,
        fuzzy=args["fuzzy"],
        sort=args["sort"],
    )

    # data response
    meta = people_data["meta"]
    people_data = people_data["data"]

    # calculate pages here since no max function in jinja2
    pagination = generate_pages(meta, limits=LIMITS_1COL, sorts=SORTS_PEOPLE)

    return render_template(
        "people.html", people_data=people_data, pagination=pagination
    )


@web_blueprint.route("/people+tags/")
@login_required
def people_and_tags():
    args = get_common_args(request, query=None, limit=10, offset=0)

    people_data = g.api.get_people(
        query=args["query"],
        limit=args["limit"],
        offset=args["offset"],
        full=True,
        fuzzy=args["fuzzy"],
        sort=args["sort"],
    )

    tag_data = g.api.get_tags(query=args["query"], limit=12, sort="count")

    # data response
    meta = people_data["meta"]
    people_data = people_data["data"]
    tag_data = tag_data["data"]

    # calculate pages here since no max function in jinja2
    pagination = generate_pages(meta, limits=LIMITS_1COL, sorts=SORTS_PEOPLE)

    return render_template(
        "people.html",
        people_data=people_data,
        pagination=pagination,
        tag_data=tag_data,
    )


@web_blueprint.route("/people/<string:crsid>")
@login_required
def person(crsid):
    person_data = g.api.get_person(crsid)

    if person_data is None:
        person_data = {"crsid": crsid}
        return render_template("noperson.html", person_data=person_data)
    else:
        edit = g.api.can_edit_crsid(crsid)
        return render_template("person.html", person_data=person_data, edit=edit)


@web_blueprint.route("/self")  # lookup.cam
@web_blueprint.route("/@self")
@web_blueprint.route("/me")
@web_blueprint.route("/@me")
@web_blueprint.route("/myself")
@web_blueprint.route("/@myself")
@web_blueprint.route("/people/@me")
@web_blueprint.route("/people/@self")
@web_blueprint.route("/people/@myself")
@login_required
def self() -> Response:
    """
    Aliases for the current user's profile.

    Any of the URLs will redirect the user to their own /people/crsid
    page. The `/self` URL mirrors lookup.cam, but there are a few
    other options if you think that `@me` makes things clearer.

    These will all have higher priority than any routes with arguments.
    """
    return redirect(url_for("web.person", crsid=g.user))


@web_blueprint.route("/tags/")
@login_required
def tags():
    args = get_common_args(request, query=None, limit=36, offset=0)

    tags_data = g.api.get_tags(
        query=args["query"],
        limit=args["limit"],
        offset=args["offset"],
        sort=args["sort"],
    )
    user_info = g.api.get_person(g.user)

    # data response
    meta = tags_data["meta"]
    tags_data = tags_data["data"]

    pagination = generate_pages(meta, limits=LIMITS_3COL, sorts=SORTS_TAGS)

    return render_template(
        "tags.html", tags_data=tags_data, pagination=pagination, user_info=user_info,
    )


# path deals with slashes in tag names
@web_blueprint.route("/tags/<path:name>/people/")
@login_required
def tag(name):
    args = get_common_args(request, limit=10, offset=0)

    tag_data = g.api.get_tag(name)

    if tag_data is None:
        return abort(404)

    tag_people_data = g.api.get_tag_people(
        name, limit=args["limit"], offset=args["offset"], full=True, sort=args["sort"],
    )

    meta = tag_people_data["meta"]
    tag_people_data = tag_people_data["data"]

    pagination = generate_pages(meta, limits=LIMITS_1COL, sorts=SORTS_PEOPLE)

    user_info = g.api.get_person(g.user)

    return render_template(
        "tag.html",
        tag=tag_data,
        tag_people=tag_people_data,
        pagination=pagination,
        user_info=user_info,
    )


@web_blueprint.route("/rooms/")
@login_required
def rooms():
    args = get_common_args(request, query=None, limit=36, offset=0)

    rooms_data = g.api.get_rooms(
        query=args["query"], limit=args["limit"], offset=args["offset"]
    )

    # data response
    meta = rooms_data["meta"]
    rooms_data = rooms_data["data"]

    pagination = generate_pages(meta, limits=LIMITS_3COL)

    user_info = g.api.get_person(g.user)

    return render_template(
        "rooms.html", rooms_data=rooms_data, pagination=pagination, user_info=user_info,
    )


@web_blueprint.route("/rooms/<string:identifier>")
@login_required
def room(identifier):
    args = get_common_args(request, limit=10, offset=0)

    room_data = g.api.get_room(identifier)

    if room_data is None:
        return abort(404)

    room_people_data = g.api.get_room_people(
        identifier,
        limit=args["limit"],
        offset=args["offset"],
        full=True,
        sort=args["sort"],
    )

    meta = room_people_data["meta"]
    room_people_data = room_people_data["data"]

    pagination = generate_pages(meta, limits=LIMITS_1COL, sorts=SORTS_PEOPLE)

lookup/http/templates/action.html
{% extends "page.html" %}
{% block title %}
    {{ g.site.short_name }}
    - Confirm action
{% endblock %}
{% block content %}
    {% if error %}
        <h1>Error</h1>
        <p>{{ error }}</p>
    {% else %}
        <h1>Confirmed</h1>
        <p>{{ data.message }}</p>
    {% endif %}
{% endblock %}

lookup/http/templates/building.html
{% extends "page.html" %}
{% from 'components.html' import paginator with context %}
{% from 'components.html' import list_people with context %}
{% block title %}
    {{ g.site.short_name }}
    -
    {{ rooms_meta.name }}
    building
{% endblock %}
{% block content %}
    <h2>
        {{ rooms_meta.name }}
    </h2>
    <div class="row">
        <div class="col-sm-3">
            <h3>Rooms</h3>
            <ul class="list-inline text-center p-3">
                {% for room in rooms %}
                    <a
                        href="{{ url_for('web.room', identifier=room.identifier) }}"
                        class="list-inline-item badge badge-room my-1"
                        {% if room.description %}
                        title="{{ room.description }}"
                        {% endif %}
                        data-mode="view"
                        data-item="{{ room|tojson|forceescape }}">
                        {{ room.number }}
                    </a>
                {% endfor %}
            </ul>
        </div>
        <div class="col-sm-9">
            <h3>People</h3>
            <div class="row justify-content-end mb-3">
                {{ paginator('web.building', pagination) }}
            </div>
            {% if people %}
                {{ list_people(people) }}
            {% else %}
                <div>
                    <a href="{{ url_for('web.rooms') }}" class="text-center">
                        <h5>No Results
                        </h5>
                    </a>
                </div>
            {% endif %}
            <div class="row justify-content-end mt-3">
                {{ paginator('web.building', pagination) }}
            </div>
        </div>
    </div>
{% endblock %}

lookup/http/templates/components.html
{% macro paginator(endpoint, pagination) %}
    {% if pagination.options.sorts %}
        <div class="mx-1">
            <select class="custom-select custom-select-sm select-href" title="Sort Results">
                <option >Sort by</option>
                {% for sort, sort_text in pagination.options.sorts %}
                    <option
                        value="{{ sort }}"
                        href="{{ url_for(endpoint, **pagination_args(pagination, sort=sort)) }}"
                        {{ "selected" if sort == pagination.sort }}>
                        {{ sort_text }}
                    </option>
                {% endfor %}
            </select>
        </div>
    {% endif %}
    {% if pagination.options.limits %}
        <div class="mx-1">
            <select class="custom-select custom-select-sm select-href" title="Results per page">
                {% for limit in pagination.options.limits %}
                    <option
                        value="{{ limit }}"
                        href="{{ url_for(endpoint, **pagination_args(pagination, limit=limit)) }}"
                        {{ "selected" if limit == pagination.limit }}>
                        {{ limit }}
                        per page
                    </option>
                {% endfor %}
            </select>
        </div>
    {% endif %}
    <ul class="pagination pagination-sm mb-0">
        {% if 'first' in pagination %}
            <li class="page-item">
                <a
                    class="page-link"
                    href="{{ url_for(endpoint, **pagination_args(pagination, offset=pagination.first)) }}"
                    aria-label="First">
                    <span>First</span>
                </a>
            </li>
        {% endif %}
        {% if 'prev' in pagination %}
            <li class="page-item">
                <a
                    class="page-link"
                    href="{{ url_for(endpoint, **pagination_args(pagination, offset=pagination.prev)) }}"
                    aria-label="Previous">
                    <span aria-hidden="true">&laquo;</span>
                    <span class="sr-only">Previous</span>
                </a>
            </li>
        {% endif %}
        {% for page, page_offset in pagination.all_pages %}
            <li
                class="d-none d-md-block page-item  {% if pagination.active_page == page %}active d-sm-block{% endif %}">
                <a
                    class="page-link"
                    href="{{ url_for(endpoint, **pagination_args(pagination, offset=page_offset)) }}">
                    {{ page }}
                </a>
            </li>
        {% endfor %}
        {% if 'next' in pagination %}
            <li class="page-item">
                <a
                    class="page-link"
                    href="{{ url_for(endpoint, **pagination_args(pagination, offset=pagination.next)) }}"
                    aria-label="Previous">
                    <span aria-hidden="true">&raquo;</span>
                    <span class="sr-only">Previous</span>
                </a>
            </li>
        {% endif %}
        {% if 'last' in pagination %}
            <li class="page-item">
                <a
                    class="page-link"
                    href="{{ url_for(endpoint, **pagination_args(pagination, offset=pagination.last)) }}"
                    aria-label="Last">
                    <span>Last</span>
                </a>
            </li>
        {% endif %}
    </ul>
{% endmacro %}
{# Lists of people used anywhere #}
{% macro list_people(people_data) %}
    <ul class="list-group">
        {% for person in people_data %}
            <a
                href="{{ url_for('web.person', crsid=person.crsid) }}"
                class="list-group-item list-group-item-action align-items-start d-flex flex-row">
                <div class="mr-3 p-0 thumbnail-container text-center align-middle">
                    {% if person.thumbnail %}
                        <img class="thumbnail-image rounded" src="data:image/png;base64, {{ person.thumbnail }}"/>
                    {% else %}
                        <span class="fas fa-user thumbnail-image"></span>
                    {% endif %}
                </div>
                <div class="flex-fill">
                    <div class="d-flex w-100 justify-content-between">
                        <h5 class="mb-1">{{ person.display_name }}</h5>
                        <code>{{ person.crsid }}</code>
                    </div>
                    <div class="d-flex w-100 justify-content-between">
                        <div>
                            {% for tag in person.tags %}
                                <span
                                    class="badge badge-tag"
                                    data-tag="{{ tag.name }}"
                                    href="{{ url_for('web.tag', name=tag.name) }}"
                                    title="{{ tag.description or '' }}">
                                    {{ tag.name }}
                                </span>
                            {% endfor %}
                            {% for room in person.rooms %}
                                <span
                                    class="badge badge-room"
                                    data-item="{{ room|tojson|forceescape }}"
                                    {% if room.description %}
                                    title="{{ room.description }}"
                                    {% endif %}
                                    href="{{ url_for('web.room', identifier=room.identifier) }}">
                                    {% if room.building and room.number %}
                                        {{ room.building }}
                                        -
                                        {{ room.number }}
                                    {% elif room.number %}
                                        {{ room.number }}
                                    {% else %}
                                        {{ room.building }}
                                    {% endif %}
                                </span>
                            {% endfor %}
                        </div>
                        <div class="text-right">
                            {% for status in person.status %}
                                <span class="badge badge-status" data-status="{{ status.name }}" title="{{ status.name or '' }}">
                                    {{ status.name }}
                                </span>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            </a>
        {% endfor %}
    </ul>
{% endmacro %}
{# Availability and status indicators #}
{% macro availability(status, id, until) %}
    {% if status == 'online' %}
        <span
            id="{{ id or '' }}"
            title="Available/Online{{ ' until ' + until|string if until }}"
            class="availability-indicator {{ status }}"></span>
    {% elif status == 'idle' %}
        <span
            id="{{ id or '' }}"
            title="Idle{{ ' until ' + until|string if until }}"
            class="availability-indicator {{ status }}"></span>
    {% elif status == 'away' %}
        <span
            id="{{ id or '' }}"
            title="Away{{ ' until ' + until|string if until }}"
            class="availability-indicator {{ status }}"></span>
    {% elif status == 'offline' %}
        <span
            id="{{ id or '' }}"
            title="Offline{{ ' until ' + until|string if until }}"
            class="availability-indicator {{ status }}"></span>
    {% elif status == 'unavailable' %}
        <span
            id="{{ id or '' }}"
            title="Unavailable{{ ' until ' + until|string if until }}"
            class="availability-indicator {{ status }}"></span>
    {% elif status == 'do-not-disturb' %}
        <span
            id="{{ id or '' }}"
            title="Do not disturb{{ ' until ' + until|string if until }}"
            class="availability-indicator {{ status }}"></span>
    {% else %}
        <span id="{{ id or '' }}" title="Availability unset" class="availability-indicator offline"></span>
    {% endif %}
{% endmacro %}

lookup/http/templates/error.html
{% extends "page.html" %}
{% block title %}
    {{ e.code }}
    {{ e.name }}
{% endblock %}
{% block content %}
    <h1>
        {{ e.code }}
        -
        {{ e.name }}
    </h1>
    <p>{{ e.description }}</p>
{% endblock %}

lookup/http/templates/page.html
<!DOCTYPE html>
<html lang="en">
    <head>
        {% block head %}
            <meta charset="utf-8"/>
            <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no"/>
            <title>
                {% block title %}
                    {{ g.site.short_name }}
                    -
                    {{ g.site.name }}
                {% endblock %}
            </title>
            <script
                src="https://code.jquery.com/jquery-3.5.1.min.js"
                integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0="
                crossorigin="anonymous"></script>
            <script src="{{ url_for('static', filename='js/main.js') }}"></script>
            <link
                href="https://fonts.googleapis.com/css?family=Lato:400,700&display=optional"
                rel="stylesheet"/>
            <link href="{{ url_for('static', filename='css/lookup.min.css') }}" rel="stylesheet"/>
            <link
                rel="stylesheet"
                href="https://use.fontawesome.com/releases/v5.12.0/css/all.css"
                integrity="sha384-REHJTs1r2ErKBuJB0fCK99gCYsVjwxHrSU0N7I1zl9vZbggVJXRMsv/sLlOAGb4M"
                crossorigin="anonymous"/>
            <link
                rel="shortcut icon"
                href="{{ url_for('static', filename='img/favicon.png') }}"
                type="image/png"/>
            <link href="{{ url_for('static', filename='css/main.css') }}" rel="stylesheet"/>
        {% endblock %}
    </head>
    <body class="bg-light">
        {% block header %}
            <header>
                <nav class="navbar navbar-expand-md navbar-dark fixed-top navbar-black">
                    <a class="navbar-brand" href="{{ url_for('web.index') }}">
                        <img
                            src="{{ url_for('static', filename='img/logo-night.svg') }}"
                            height="30"
                            class="d-inline-block align-top"/>
                        <strong>{{ g.site.logo_text[0] }}</strong>{{ g.site.logo_text[1] }}
                    </a>
                    <button
                        class="navbar-toggler"
                        type="button"
                        data-toggle="collapse"
                        data-target="#navbar-content"
                        aria-controls="navbar-content"
                        aria-expanded="false"
                        aria-label="Toggle navigation">
                        <span class="navbar-toggler-icon"></span>
                    </button>
                    <div class="collapse navbar-collapse" id="navbar-content">
                        <ul class="navbar-nav mr-auto">
                            <li class="nav-item">
                                <a class="nav-link" href="{{ url_for('web.people') }}" title="People">People</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{{ url_for('web.tags') }}" title="Tags">Tags</a>
                            </li>
                            <li class="nav-item">
                                <a class="nav-link" href="{{ url_for('web.rooms') }}" title="Rooms">Rooms</a>
                            </li>
                        </ul>
                        {% if get_current_user() %}
                            <ul class="navbar-nav">
                                <li
                                    class="nav-item"
                                    {% if user_info %}
                                    id="user-info"
                                    data-user-info="{{ user_info|tojson|forceescape }}"
                                    {% endif %}>
                                    <a
                                        class="nav-link"
                                        href="{{ url_for('web.person', crsid=get_current_user()) }}"
                                        title="My profile page">Profile ({{ get_current_user() }})</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ url_for('web.logout') }}" title="Logout current user">Logout</a>
                                </li>
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ url_for('web.settings') }}" title="Settings">
                                        <span class="fas fa-cog"></span></a>
                                </li>
                                <li class="nav-item">
                                    <label for="select-scope" class="sr-only">
                                        Institutional scope
                                    </label>
                                    <select
                                        id="select-scope"
                                        class="custom-select bg-transparent border-0 pt-2
                                            {% if not request.cookies.scope or request.cookies.scope == 'local' %}
                                            text-secondary
                                            {% else %}
                                            text-light font-weight-bold
                                            {% endif %}"
                                        title="Select an institutional scope for browsing.">
                                        <option disabled="disabled" {% if not request.cookies.scope %} selected="selected" {% endif %}>Scope</option>
                                        <option
                                            value="local"
                                            {% if request.cookies.scope == "local" %}
                                            selected="selected"
                                            {% endif %}
                                            title="Show results for the institution being browsed.">Local</option>
                                        <option
                                            value="all"
                                            {% if request.cookies.scope == "all" %}
                                            selected="selected"
                                            {% endif %}
                                            title="Show results for all institutions.">All</option>
                                        {% if request.cookies.scope and request.cookies.scope not in["all", "local"] %}
                                            <option value="{{ request.cookies.scope }}" selected="selected">{{ request.cookies.scope }}</option>
                                        {% endif %}
                                    </select>
                                </li>
                            </ul>
                            <form
                                class="form-inline navbar-nav nav-item"
                                id="quick-search-form"
                                action="{{ url_for('web.people') }}">
                                <div class="form-group dropdown">
                                    <input
                                        class="form-control"
                                        title="quick-search"
                                        placeholder="Quick Search"
                                        type="text"
                                        name="query"
                                        id="quick-search"
                                        data-toggle="dropdown"/>
                                    <input type="hidden" name="fuzzy" value="true"/>
                                    <div id="quick-search-output"></div>
                                </div>
                            </form>
                        {% else %}
                            <ul class="navbar-nav">
                                <li class="nav-item">
                                    <a class="nav-link" href="{{ url_for('web.login') }}">Login</a>
                                </li>
                            </ul>
                            <div class="form-inline">
                                <div class="form-control text-center">
                                    <a class="text-dark" href="{{ url_for('web.login') }}">Login to search</a>
                                </div>
                            </div>
                        {% endif %}
                    </div>
                </nav>
            </header>
        {% endblock %}
        <main role="main" class="container mt-5 pt-5 mb-5 pb-5">
            {% block content %}
                <p>No content</p>
            {% endblock content %}
        </main>
        {% block footer %}
            <footer class="footer d-none d-sm-inline">
                <nav class="navbar navbar-expand-md navbar-dark navbar-black fixed-bottom">
                    <a class="navbar-brand" href="https://itservices.phy.cam.ac.uk/" target="_blank">
                        <img
                            src="{{ url_for('static', filename='img/it-services-negative.png') }}"
                            height="50"
                            style="margin:-0.5rem"/>
                    </a>
                    <ul class="navbar-nav mr-auto">
                        <li class="nav-item">
                            <span class="nav-link text-secondary">
                                Contact:
                                <code>
                                    <a href="mailto:{{ g.site.support_email }}?subject=[lookup] query" class="text-light">{{ g.site.support_email }}</a>
                                </code>
                            </span>
                        </li>
                    </ul>
                    <ul class="navbar-nav">
                        <li class="nav-item">
                            <a class="nav-link" href="{{ url_for('web.privacy') }}">Privacy</a>
                        </li>
                    </ul>
                </nav>
            </footer>
        {% endblock %}
        {% block bootstrap %}
            <script
                src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js"
                integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo"
                crossorigin="anonymous"></script>
            <script
                src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js"
                integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI"
                crossorigin="anonymous"></script>
            <script
                src="https://cdnjs.cloudflare.com/ajax/libs/markdown-it/10.0.0/markdown-it.js"
                integrity="sha256-uhsZv/1rhiqa0K9vDMZzGa5ZEFVECUsJ1yQ7qtShRlc="
                crossorigin="anonymous"></script>
        {% endblock %}
    </body>
</html>